
--localization
L = LibStub ("AceLocale-3.0"):GetLocale("Minesweeperr", true)
local classIdx = {
   [1] = "warrior",
   [2] = "paladin",
   [3] = "hunter",
   [4] = "rogue",
   [5] = "priest",
   [6] = "dk",
   [7] = "shaman",
   [8] = "mage",
   [9] = "warlock",
   [10] = "monk",
   [11] = "druid",
   [12] = "dh"}

dungeonIds = { 12749, 12752, 12763, 12768, 12773, 12776, 12779, 12745, 12782, 12785 }
dungeonNames = {
    L["D_AD"],
    L["D_FH"],
    L["D_KR"],
    L["D_SOTS"],
    L["D_SOB"],
    L["D_TOSL"],
    L["D_TML"],
    L["D_TUR"],
    L["D_TD"],
    L["D_WM"],
}

_PLAYER_GUID = nil

function toString(tbl)
    local result = "{"
    for k, v in pairs(tbl) do
       -- Check the key type (ignore any numerical keys - assume its an array)
       if type(k) == "string" then
          result = result.."[\""..k.."\"]".."="
       end
       
       -- Check the value type
       if type(v) == "table" then
          result = result..table_to_string(v)
       elseif type(v) == "boolean" then
          result = result..tostring(v)
       else
          result = result.."\""..v.."\""
       end
       result = result..","
    end
    -- Remove leading commas from the result
    if result ~= "{" then
       result = result:sub(1, result:len()-1)
    end
    return result.."}"
 end


function Striping(f)
    assert(f, "doesn't exist!")
	local frameName = f.GetName and f:GetName()
	if f.styling then return end
	local style = CreateFrame("Frame", frameName or nil, f)
    local stripes = f:CreateTexture(f:GetName() and f:GetName().."Overlay" or nil, "BORDER", f)
    stripes:ClearAllPoints()
    stripes:SetPoint("TOPLEFT", 1, -1)
    stripes:SetPoint("BOTTOMRIGHT", -1, 1)
    stripes:SetTexture([[Interface\AddOns\Minesweeperr\media\stripes]], true, true)
    stripes:SetHorizTile(true)
    stripes:SetVertTile(true)
    stripes:SetBlendMode("ADD")
    style.stripes = stripes
	style:SetFrameLevel(f:GetFrameLevel() + 1)
	f.styling = style
end

function setFrameTexture(self, edgeSize, bgTexture)
   if not bgTexture then
      bgTexture = "Interface\\AddOns\\Minesweeperr\\Media\\Square_FullWhite"
   end
   self:SetBackdrop({
         bgFile = bgTexture,
         insets = {left = 1,right = 1,top = 1,bottom = 1},
         edgeFile = "Interface\\AddOns\\Minesweeperr\\Media\\Square_FullWhite",
         edgeSize = edgeSize,
   })
end

local waitTable = {};
local waitFrame = nil;
function MS_wait(delay, func, ...)
   if(type(delay)~="number" or type(func)~="function") then
      return false;
   end
   if(waitFrame == nil) then
      waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
      waitFrame:SetScript("onUpdate", function (self,elapse)
            local count = #waitTable;
            local i = 1;
            while(i<=count) do
               local waitRecord = tremove(waitTable,i);
               local d = tremove(waitRecord,1);
               local f = tremove(waitRecord,1);
               local p = tremove(waitRecord,1);
               if(d>elapse) then
                  tinsert(waitTable,i,{d-elapse,f,p});
                  i = i + 1;
               else
                  count = count - 1;
                  f(unpack(p));
               end
            end
      end);
   end
   tinsert(waitTable,{delay,func,{...}});
   return true;
end


function getAchievementData(self, event, guid)
    if guid == _ACHI_FLAGKEY then
        local isMaster = nil
        local completed, month, day, year = GetAchievementComparisonInfo(14145)
        if completed 
        then
            isMaster = year.."/"..month.."/"..day
        else
            isMaster = 0
        end
        local count = {}
        for i = 1, table.getn(dungeonIds), 1
        do
            count[dungeonIds[i]] = GetComparisonStatistic(dungeonIds[i])
        end
        _DB[guid]["isMaster"] = isMaster
        _DB[guid]["count"] = count
    end
    refreshPlayerPanels()
end

local corruptionData = {
    ["6483"] = {spellID = 315607, level = "I", value = 8},
    ["6484"] = {spellID = 315608, level = "II", value = 12},
    ["6485"] = {spellID = 315609, level = "III", value = 16},
    ["6474"] = {spellID = 315544, level = "I", value = 10},
    ["6475"] = {spellID = 315545, level = "II", value = 15},
    ["6476"] = {spellID = 315546, level = "III", value = 20},
    ["6471"] = {spellID = 315529, level = "I", value = 10},
    ["6472"] = {spellID = 315530, level = "II", value = 15},
    ["6473"] = {spellID = 315531, level = "III", value = 20},
    ["6480"] = {spellID = 315554, level = "I", value = 10},
    ["6481"] = {spellID = 315557, level = "II", value = 15},
    ["6482"] = {spellID = 315558, level = "III", value = 20},
    ["6477"] = {spellID = 315549, level = "I", value = 10},
    ["6478"] = {spellID = 315552, level = "II", value = 15},
    ["6479"] = {spellID = 315553, level = "III", value = 20},
    ["6493"] = {spellID = 315590, level = "I", value = 17},
    ["6494"] = {spellID = 315591, level = "II", value = 28},
    ["6495"] = {spellID = 315592, level = "III", value = 45},
    ["6437"] = {spellID = 315277, level = "I", value = 10},
    ["6438"] = {spellID = 315281, level = "II", value = 15},
    ["6439"] = {spellID = 315282, level = "III", value = 20},
    ["6555"] = {spellID = 318266, level = "I", value = 15},
    ["6559"] = {spellID = 318492, level = "II", value = 20},
    ["6560"] = {spellID = 318496, level = "III", value = 35},
    ["6556"] = {spellID = 318268, level = "I", value = 15},
    ["6561"] = {spellID = 318493, level = "II", value = 20},
    ["6562"] = {spellID = 318497, level = "III", value = 35},
    ["6558"] = {spellID = 318270, level = "I", value = 15},
    ["6565"] = {spellID = 318495, level = "II", value = 20},
    ["6566"] = {spellID = 318499, level = "III", value = 35},
    ["6557"] = {spellID = 318269, level = "I", value = 15},
    ["6563"] = {spellID = 318494, level = "II", value = 20},
    ["6564"] = {spellID = 318498, level = "III", value = 35},
    ["6549"] = {spellID = 318280, level = "I", value = 25},
    ["6550"] = {spellID = 318485, level = "II", value = 35},
    ["6551"] = {spellID = 318486, level = "III", value = 60},
    ["6552"] = {spellID = 318274, level = "I", value = 20},
    ["6553"] = {spellID = 318487, level = "II", value = 50},
    ["6554"] = {spellID = 318488, level = "III", value = 75},
    ["6547"] = {spellID = 318303, level = "I", value = 12},
    ["6548"] = {spellID = 318484, level = "II", value = 30},
    ["6537"] = {spellID = 318276, level = "I", value = 25},
    ["6538"] = {spellID = 318477, level = "II", value = 50},
    ["6539"] = {spellID = 318478, level = "III", value = 75},
    ["6543"] = {spellID = 318481, level = "I", value = 10},
    ["6544"] = {spellID = 318482, level = "II", value = 35},
    ["6545"] = {spellID = 318483, level = "III", value = 66},
    ["6540"] = {spellID = 318286, level = "I", value = 15},
    ["6541"] = {spellID = 318479, level = "II", value = 35},
    ["6542"] = {spellID = 318480, level = "III", value = 66},
    ["6573"] = {spellID = 318272, level = "", value = 15},
    ["6546"] = {spellID = 318239, level = "", value = 15},
    ["6571"] = {spellID = 318293, level = "", value = 30},
    ["6572"] = {spellID = 316651, level = "", value = 50},
    ["6567"] = {spellID = 318294, level = "", value = 35},
    ["6568"] = {spellID = 316780, level = "", value = 25},
    ["6570"] = {spellID = 318299, level = "", value = 20},
    ["6569"] = {spellID = 317290, level = "", value = 25},
}


local linkCache = {}
function Corruption_Search(link)
    local value = linkCache[link]
    if not value then
        local itemString = strmatch(link, "item:([%-?%d:]+)")
        for index in gmatch(itemString, "%d+") do
            if corruptionData[index] then
                value = corruptionData[index]
                linkCache[link] = value
                break
            end
        end
    end
    return value
end


local TEMPTIP = CreateFrame("GameTooltip", "TempTooltip", nil, "GameTooltipTemplate")
local essenceTextureIDs = {
    [2967101] = true,
    [3193842] = true,
    [3193843] = true,
    [3193844] = true,
    [3193845] = true,
    [3193846] = true,
    [3193847] = true,
}
local cloakResString = "(%d+)%s?"..ITEM_MOD_CORRUPTION_RESISTANCE

local GEM_SLOTS = {
    EMPTY_SOCKET = true,
    EMPTY_SOCKET_BLUE = true,
    EMPTY_SOCKET_COGWHEEL = true,
    EMPTY_SOCKET_HYDRAULIC = true,
    EMPTY_SOCKET_META = true,
    EMPTY_SOCKET_NO_COLOR = true,
    EMPTY_SOCKET_PRISMATIC = true,
    EMPTY_SOCKET_RED = true,
    EMPTY_SOCKET_YELLOW = true,
    EMPTY_SOCKET_PUNCHCARDYELLOW = false,
    EMPTY_SOCKET_PUNCHCARDRED = false,
    EMPTY_SOCKET_PUNCHCARDBLUE = false,
}


function getGearData(self, event, guid)
    if guid == _GEAR_FLAGKEY then
        local totalIlvl = 0
        local mainHandEquipLoc, offHandEquipLoc
        local totalCorruption = 0

        -- --------------------
        local resistance = 0
        -- 计算精华减免
        TEMPTIP:SetOwner(UIParent, "ANCHOR_NONE")
        TEMPTIP:SetInventoryItem(_DB[guid]["uid"], 2)
        for i = 1, 10 do
            local tex = _G[TEMPTIP:GetName().."Texture"..i]
            local texture = tex and tex:IsShown() and tex:GetTexture()
            if texture and essenceTextureIDs[texture] then
                resistance = 10
                break
            end
        end

        -- ---------------------
        -- 计算披风减免
        TEMPTIP:SetOwner(UIParent, "ANCHOR_NONE")
        TEMPTIP:SetInventoryItem(_DB[guid]["uid"], 15)
        for i = 1, TEMPTIP:NumLines() do
            local line = _G[TEMPTIP:GetName().."TextLeft"..i]
            local text = line and line:GetText()
            local value = text and strmatch(text, cloakResString)
            if value then
                resistance = resistance + value
            end
        end

        local slot_count = 0

        for slot = INVSLOT_FIRST_EQUIPPED, INVSLOT_LAST_EQUIPPED do -- For every slot,
           if slot ~= INVSLOT_BODY and slot ~= INVSLOT_TABARD then -- If this isn't the shirt/tabard slot,
              local link = GetInventoryItemLink(_DB[guid]["uid"], slot) -- Get the ID of the item in this slot
              if link then -- If we have an item in this slot,
                -- iLvl
                 local _, _, _, itemLevel, _, _, _, _, itemEquipLoc = GetItemInfo(link) -- Get the item's ilvl and equip location
                 totalIlvl = totalIlvl + itemLevel -- Add it to the total
                 if slot == INVSLOT_MAINHAND then -- If this is the main or off hand, store the equip location for later use
                    mainHandEquipLoc = itemEquipLoc
                 elseif slot == INVSLOT_OFFHAND then
                    offHandEquipLoc = itemEquipLoc
                 end

                 -- Corruption
                 if IsCorruptedItem(link) then
                    local value = Corruption_Search(link)
                    totalCorruption = totalCorruption + value["value"]
                end

                -- Gem slot
                local _item_stat_tbl = {}
                wipe(_item_stat_tbl)
                local stats = GetItemStats(link, _item_stat_tbl)
                if stats
                then 
                    for k, v in next, stats do
                        if(GEM_SLOTS[k]) then
                            slot_count = slot_count + v
                        end
                    end
                end
              end
           end
        end
        
        local numSlots
        if mainHandEquipLoc and offHandEquipLoc then -- The unit has something in both hands, set numSlots to 17
           numSlots = 16
        else
           numSlots = 15
        end
        _DB[guid]["ilvl"] = math.modf(totalIlvl / numSlots) -- Return the average
        _DB[guid]["corruption"] = totalCorruption - resistance
        _DB[guid]["gemSlot"] = slot_count
    end
    refreshPlayerPanels()
end


-- ---------------------
-- Display

function refreshElements(panel, unitInfo)
    if unitInfo
    then
        panel.name:SetText(unitInfo["name"])
        panel.server:SetText(unitInfo["server"])
        setFrameTexture(panel.classIcon, 0, "Interface\\Addons\\Minesweeperr\\media\\classicons\\"..classIdx[unitInfo["classIndex"]])
        panel.classIcon:SetBackdropBorderColor(0, 0, 0, 0)
        if unitInfo["isMaster"]
        then
            if unitInfo["isMaster"] ~= 0 then
                setFrameTexture(panel.keymasterIcon, 0, "Interface\\Addons\\Minesweeperr\\media\\achi")
                panel.masterDate:SetText(unitInfo["isMaster"])
            else
                setFrameTexture(panel.keymasterIcon, 0, "Interface\\Addons\\Minesweeperr\\media\\unachi")
                panel.masterDate:SetText("未完成")
            end
        else
            setFrameTexture(panel.keymasterIcon, 0, "Interface\\Addons\\Minesweeperr\\media\\unachi")
            panel.masterDate:SetText("待获取")
        end
        panel.keymasterIcon:SetBackdropBorderColor(0.7, 0.7, 0.7, 0)
        if unitInfo["count"] then
            for i = 1, getn(dungeonIds), 1
            do
                count = unitInfo["count"][dungeonIds[i]]
                panel.countIcons[i].countnum = count
                if count == "--"
                then
                    count = 0
                end
                count = tonumber(count)
                if count > 20
                then
                    count = 20
                end
                panel.countIcons[i]:SetBackdropColor(0.2+0.6*count/20, 0.2, 0.2, 1)
            end
        else
            for i = 1, getn(dungeonIds), 1
            do
                panel.countIcons[i].countnum = 0
                panel.countIcons[i]:SetBackdropColor(0.2, 0.2, 0.2, 1)
            end
        end
        if unitInfo["ilvl"] then
            panel.iLvl.text:SetText(unitInfo["ilvl"])
        else
            panel.iLvl.text:SetText("--")
        end
        if unitInfo["corruption"] then
            panel.corruption.text:SetText(unitInfo["corruption"])
        else
            panel.corruption.text:SetText("--")
        end
        if unitInfo["gemSlot"] then
            panel.gem.text:SetText(unitInfo["gemSlot"])
        else
            panel.gem.text:SetText("--")
        end
        if unitInfo["role"] and unitInfo["role"] ~= "NONE"then
            setFrameTexture(panel.roleIcon, 0, "Interface\\Addons\\Minesweeperr\\media\\"..unitInfo["role"])
            panel.roleIcon:SetBackdropColor(0.7, 0.7, 0.7, 1)
            panel.roleIcon:SetBackdropBorderColor(0, 0, 0, 0)
        else
            panel.roleIcon:SetBackdropColor(0.7, 0.7, 0.7, 0)
        end
        if unitInfo["rating"] then
            panel.rating = unitInfo["rating"]
            if tonumber(panel.rating) == 1 then
                panel.rateGoodIcon:SetBackdropColor(0.9, 0.9, 0.9, 1)
                panel.rateBadIcon:SetBackdropColor(0.3, 0.3, 0.3, 1)
            else
                panel.rateGoodIcon:SetBackdropColor(0.3, 0.3, 0.3, 1)
                panel.rateBadIcon:SetBackdropColor(0.9, 0.9, 0.9, 1)
            end
        else
            panel.rateGoodIcon:SetBackdropColor(0.3, 0.3, 0.3, 1)
            panel.rateBadIcon:SetBackdropColor(0.3, 0.3, 0.3, 1)
        end

        if getN(unitInfo["good_rating_count"]) > 0 then
            panel.rateGoodIcon.text:SetText(getN(unitInfo["good_rating_count"]))
        else
            panel.rateGoodIcon.text:SetText("")
        end
        if getN(unitInfo["bad_rating_count"]) > 0 then
            panel.rateBadIcon.text:SetText(getN(unitInfo["bad_rating_count"]))
        else
            panel.rateBadIcon.text:SetText("")
        end
    end
end

function refreshPlayerPanels(self, event)
    if _REFRESH_ACHI_FLAG == 1 or _REFRESH_GEAR_FLAG == 1 then
        mainFrame.refreshMaskFrame:Show()
    end
    local membersNum = getN(_DB);
    for j = (membersNum+1), 5, 1
    do
        _M.panels[j]:Hide()
    end
    local i = 1
    for key, value in pairs(_DB)
    do
        if key ~= 1
        then
            _M.panels[i]:Show()
            _M.panels[i].guid = key
            refreshElements(_M.panels[i], _DB[key])
            i = i + 1
        end
    end
end


function registerTooltip(frame, text)
    frame:EnableMouse(true)
    frame:SetScript('OnEnter', function()
        GameTooltip:Hide()
        GameTooltip:SetOwner(frame, "ANCHOR_RIGHT")
        GameTooltip:AddLine("|cFFFFFFFF" .. text)
        GameTooltip:Show()
    end)
    frame:SetScript('OnLeave', function() GameTooltip:Hide() end)
end


function createBasicUI()
    -- --------------------
    -- Main Frame
    local mainFrame = CreateFrame("Frame", "MSMainFrame", UIParent)
    tinsert(UISpecialFrames, mainFrame:GetName())
    mainFrame:SetFrameLevel(5)
    mainFrame:SetSize(1160, 520)
    setFrameTexture(mainFrame, 1)
    Striping(mainFrame)
    mainFrame:SetBackdropColor(0, 0, 0, 0.7)
    mainFrame:SetBackdropBorderColor(0, 0, 0, 1)
    mainFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 0)

    -- make main Frame movable
    mainFrame:SetMovable(true)
    mainFrame:EnableMouse(true)
    mainFrame:RegisterForDrag("LeftButton")
    mainFrame:SetScript("OnDragStart", mainFrame.StartMoving)
    mainFrame:SetScript("OnDragStop", mainFrame.StopMovingOrSizing)



    -- --------------------
    -- Title Box
    local titleBox = CreateFrame("Frame", nil, mainFrame)
    Striping(titleBox)
    titleBox:SetSize(160, 50)
    setFrameTexture(titleBox, 0)
    titleBox:SetBackdropColor(0, 0, 0, 0.9)
    titleBox:SetBackdropBorderColor(0, 0, 0, 1)
    titleBox:SetPoint("TOP", mainFrame, "TOP", 0, 20)
    titleBox.Text = titleBox:CreateFontString(nil, "OVERLAY")
    titleBox.Text:SetFont("Interface\\Addons\\Minesweeperr\\media\\font.ttf", 30, "THINOUTLINE") 
    titleBox.Text:SetText("Minesweeperr")
    titleBox.Text:SetPoint("CENTER", titleBox, "CENTER", 0, 0)

    -- --------------------
    -- Close Btn
    local closeBtn = CreateFrame("Frame", nil, mainFrame)
    closeBtn:SetSize(120, 30)
    setFrameTexture(closeBtn, 0, "Interface\\Addons\\Minesweeperr\\media\\normTex")
    closeBtn:SetBackdropColor(0, 0, 0, 0.9)
    closeBtn:SetBackdropBorderColor(0, 0, 0, 1)
    closeBtn:SetPoint("BOTTOM", mainFrame, "BOTTOM", 300, 15)
    closeBtn.Text = closeBtn:CreateFontString(nil, "OVERLAY")
    closeBtn.Text:SetTextColor(0.8, 0.8, 0.8, 1)
    closeBtn.Text:SetFont("Interface\\Addons\\Minesweeperr\\media\\font.ttf", 14, "THINOUTLINE") 
    closeBtn.Text:SetText(L["Close"])
    closeBtn.Text:SetPoint("CENTER", closeBtn, "CENTER", 0, 0)
    closeBtn:EnableMouse(true)
    closeBtn:SetScript("OnMouseUp", function(self) self:GetParent():Hide() end)
    closeBtn:SetScript('OnEnter', function() closeBtn:SetBackdropColor(0.1, 0.1, 0.1, 0.9) end)
    closeBtn:SetScript('OnLeave', function() closeBtn:SetBackdropColor(0, 0, 0, 0.9) end)

    -- --------------------
    -- Refresh Btn
    local refreshBtn = CreateFrame("Frame", nil, mainFrame)
    refreshBtn:SetSize(120, 30)
    setFrameTexture(refreshBtn, 0, "Interface\\Addons\\Minesweeperr\\media\\normTex")
    refreshBtn:SetBackdropColor(0, 0, 0, 0.9)
    refreshBtn:SetBackdropBorderColor(0, 0, 0, 1)
    refreshBtn:SetPoint("BOTTOM", mainFrame, "BOTTOM", 0, 15)
    refreshBtn.Text = refreshBtn:CreateFontString(nil, "OVERLAY")
    refreshBtn.Text:SetTextColor(0.8, 0.8, 0.8, 1)
    refreshBtn.Text:SetFont("Interface\\Addons\\Minesweeperr\\media\\font.ttf", 14, "THINOUTLINE") 
    refreshBtn.Text:SetText(L["Refresh"])
    refreshBtn.Text:SetPoint("CENTER", refreshBtn, "CENTER", 0, 0)
    refreshBtn:EnableMouse(true)
    refreshBtn:SetScript("OnMouseUp", getMemberBasicData)
    refreshBtn:SetScript('OnEnter', function() refreshBtn:SetBackdropColor(0.1, 0.1, 0.1, 0.9) end)
    refreshBtn:SetScript('OnLeave', function() refreshBtn:SetBackdropColor(0, 0, 0, 0.9) end)

    local panels = {}
    for i = 1, 5, 1
    do
        -- Player Info Panel
        local playerPanel = CreateFrame("Frame", "PlayerInfoPanel"..i, mainFrame)
        playerPanel:SetSize(220, 420)
        setFrameTexture(playerPanel, 0)
        Striping(playerPanel)
        playerPanel:SetBackdropColor(0, 0, 0, 0.8)
        playerPanel:SetBackdropBorderColor(0, 0, 0, 0)
        playerPanel:SetPoint("TOPLEFT", mainFrame, "TOPLEFT", 10+(i-1)*230, -40)

        -- Player name and server
        playerPanel.name = playerPanel:CreateFontString(nil, "OVERLAY")
        playerPanel.name:SetFont("Interface\\Addons\\Minesweeperr\\media\\font.ttf", 16, "THINOUTLINE")
        playerPanel.name:SetText("TestName")
        playerPanel.name:SetPoint("TOP", playerPanel, "TOP", 0, -120)

        playerPanel.server = playerPanel:CreateFontString(nil, "OVERLAY")
        playerPanel.server:SetFont("Interface\\Addons\\Minesweeperr\\media\\font.ttf", 12, "THINOUTLINE")
        playerPanel.server:SetText("TestServer")
        playerPanel.server:SetPoint("TOP", playerPanel, "TOP", 0, -150)
        playerPanel.server:SetTextColor(0.5, 0.5, 0.5, 1)

        -- Player iLvl and Corruption and Gem
        playerPanel.iLvl = CreateFrame("Frame", "ItemLevel"..i, playerPanel)
        playerPanel.iLvl:SetSize(16, 16)
        setFrameTexture(playerPanel.iLvl, 0, "Interface\\Addons\\Minesweeperr\\media\\ilvl")
        playerPanel.iLvl:SetBackdropBorderColor(0, 0, 0, 0)
        playerPanel.iLvl:SetPoint("TOPLEFT", playerPanel, "TOPLEFT", 30, -180)
        playerPanel.iLvl.text = playerPanel.iLvl:CreateFontString(nil, "OVERLAY")
        playerPanel.iLvl.text:SetFont("Interface\\Addons\\Minesweeperr\\media\\font.ttf", 12, "THINOUTLINE")
        playerPanel.iLvl.text:SetText("--")
        playerPanel.iLvl.text:SetPoint("LEFT", playerPanel.iLvl, "RIGHT", 5, 0)
        playerPanel.iLvl.text:SetTextColor(0.7, 0.7, 0.7, 1)
        registerTooltip(playerPanel.iLvl, "装备平均等级")

        playerPanel.corruption = CreateFrame("Frame", "ItemLevel"..i, playerPanel)
        playerPanel.corruption:SetSize(16, 16)
        setFrameTexture(playerPanel.corruption, 0, "Interface\\Addons\\Minesweeperr\\media\\corruption")
        playerPanel.corruption:SetBackdropBorderColor(0, 0, 0, 0)
        playerPanel.corruption:SetPoint("TOPLEFT", playerPanel, "TOPLEFT", 85, -180)
        playerPanel.corruption.text = playerPanel.corruption:CreateFontString(nil, "OVERLAY")
        playerPanel.corruption.text:SetFont("Interface\\Addons\\Minesweeperr\\media\\font.ttf", 12, "THINOUTLINE")
        playerPanel.corruption.text:SetText("--")
        playerPanel.corruption.text:SetPoint("LEFT", playerPanel.corruption, "RIGHT", 5, 0)
        playerPanel.corruption.text:SetTextColor(0.7, 0.7, 0.7, 1)
        registerTooltip(playerPanel.corruption, "腐蚀值")

        playerPanel.gem = CreateFrame("Frame", "ItemLevel"..i, playerPanel)
        playerPanel.gem:SetSize(16, 16)
        setFrameTexture(playerPanel.gem, 0, "Interface\\Addons\\Minesweeperr\\media\\gem")
        playerPanel.gem:SetBackdropBorderColor(0, 0, 0, 0)
        playerPanel.gem:SetPoint("TOPLEFT", playerPanel, "TOPLEFT", 130, -180)
        playerPanel.gem.text = playerPanel.gem:CreateFontString(nil, "OVERLAY")
        playerPanel.gem.text:SetFont("Interface\\Addons\\Minesweeperr\\media\\font.ttf", 12, "THINOUTLINE")
        playerPanel.gem.text:SetText("--")
        playerPanel.gem.text:SetPoint("LEFT", playerPanel.gem, "RIGHT", 5, 0)
        playerPanel.gem.text:SetTextColor(0.7, 0.7, 0.7, 1)
        registerTooltip(playerPanel.gem, "宝石数量")

        -- Class Icon
        playerPanel.classIcon = CreateFrame("Frame", "ClassIcon"..i, playerPanel)
        playerPanel.classIcon:SetSize(64, 64)
        setFrameTexture(playerPanel.classIcon, 0, "Interface\\Addons\\Minesweeperr\\media\\classicons\\none")
        playerPanel.classIcon:SetBackdropBorderColor(0, 0, 0, 0)
        playerPanel.classIcon:SetPoint("TOP", playerPanel, "TOP", 0, -30)

        -- Role Icon
        playerPanel.roleIcon = CreateFrame("Frame", "RoleIcon"..i, playerPanel)
        playerPanel.roleIcon:SetSize(16, 16)
        setFrameTexture(playerPanel.roleIcon, 0, "Interface\\Addons\\Minesweeperr\\media\\TANK")
        playerPanel.roleIcon:SetBackdropColor(0.7, 0.7, 0.7, 0)
        playerPanel.roleIcon:SetBackdropBorderColor(0, 0, 0, 0)
        playerPanel.roleIcon:SetPoint("TOPLEFT", playerPanel, "TOPLEFT", 175, -180)

        -- Keystone Master Icon
        playerPanel.keymasterIcon = CreateFrame("Frame", "KeyStoneMasterIcon"..i, playerPanel)
        playerPanel.keymasterIcon:SetSize(64, 64)
        setFrameTexture(playerPanel.keymasterIcon, 0, "Interface\\Addons\\Minesweeperr\\media\\unachi")
        playerPanel.keymasterIcon:SetBackdropBorderColor(0, 0, 0, 0)
        playerPanel.keymasterIcon:SetPoint("TOP", playerPanel, "TOP", 0, -220)
        playerPanel.keymasterIcon:EnableMouse(true)
        registerTooltip(playerPanel.keymasterIcon, "史诗钥石地下城大师：第四赛季")

        playerPanel.masterDate = playerPanel:CreateFontString(nil, "OVERLAY")
        playerPanel.masterDate:SetFont("Interface\\Addons\\Minesweeperr\\media\\font.ttf", 12, "THINOUTLINE")
        playerPanel.masterDate:SetText("待刷新")
        playerPanel.masterDate:SetPoint("TOP", playerPanel, "TOP", 0, -290)
        playerPanel.masterDate:SetTextColor(0.5, 0.5, 0.5, 1)

        local countIcons = {}
        for j = 1, getn(dungeonIds), 1
        do
            local countIcon = CreateFrame("Frame", "CountIcon"..i..j, playerPanel)
            countIcon:SetSize(16, 16)
            setFrameTexture(countIcon, 1, "Interface\\Addons\\Minesweeperr\\media\\normTex")
            countIcon:SetBackdropBorderColor(0, 0, 0, 1)
            countIcon:SetBackdropColor(0.2, 0.2, 0.2, 1)
            countIcon:SetPoint("TOPLEFT", playerPanel, "TOPLEFT", 68 + math.fmod((j-1), 5) * 16, -335 + math.modf((j-1)/5) * 16)
            local countnum = "待获取"
            countIcon.countnum = countnum
            countIcon:SetScript('OnEnter', function()
                GameTooltip:Hide()
                GameTooltip:SetOwner(countIcon, "ANCHOR_RIGHT")
                GameTooltip:AddLine("|cFFFFFFFF" .. dungeonNames[j]..": "..countIcon.countnum)
                GameTooltip:Show()
            end)
            countIcon:SetScript('OnLeave', function() GameTooltip:Hide() end)

            countIcons[j] = countIcon
        end
        playerPanel.countIcons = countIcons

        -- Rating Icon
        playerPanel.rateGoodIcon = CreateFrame("Frame", "RateGood"..i, playerPanel)
        playerPanel.rateGoodIcon:SetSize(20, 20)
        setFrameTexture(playerPanel.rateGoodIcon, 0, "Interface\\Addons\\Minesweeperr\\media\\good")
        playerPanel.rateGoodIcon:SetBackdropColor(0.5, 0.5, 0.5, 1)
        playerPanel.rateGoodIcon:SetBackdropBorderColor(0, 0, 0, 0)
        playerPanel.rateGoodIcon:SetPoint("TOP", playerPanel, "TOP", -40, -375)
        playerPanel.rateGoodIcon:EnableMouse(true)
        playerPanel.rateGoodIcon:SetScript('OnEnter', function() playerPanel.rateGoodIcon:SetSize(24, 24) end)
        playerPanel.rateGoodIcon:SetScript('OnLeave', function() playerPanel.rateGoodIcon:SetSize(20, 20) end)
        playerPanel.rateGoodIcon:SetScript("OnMouseUp", function()
            playerPanel.rateGoodIcon:SetBackdropColor(0.9, 0.9, 0.9, 1)
            playerPanel.rateBadIcon:SetBackdropColor(0.3, 0.3, 0.3, 1)
            playerPanel.rating = 1
            saveRating(playerPanel)
        end)
        playerPanel.rateGoodIcon.text = playerPanel:CreateFontString(nil, "OVERLAY")
        playerPanel.rateGoodIcon.text:SetFont("Interface\\Addons\\Minesweeperr\\media\\font.ttf", 12, "THINOUTLINE")
        playerPanel.rateGoodIcon.text:SetText("")
        playerPanel.rateGoodIcon.text:SetPoint("LEFT", playerPanel.rateGoodIcon, "RIGHT", 5, 0)
        playerPanel.rateGoodIcon.text:SetTextColor(0.6, 0.6, 0.6, 1)

        playerPanel.rateBadIcon = CreateFrame("Frame", "RateBad"..i, playerPanel)
        playerPanel.rateBadIcon:SetSize(20, 20)
        setFrameTexture(playerPanel.rateBadIcon, 0, "Interface\\Addons\\Minesweeperr\\media\\bad")
        playerPanel.rateBadIcon:SetBackdropColor(0.5, 0.5, 0.5, 1)
        playerPanel.rateBadIcon:SetBackdropBorderColor(0, 0, 0, 0)
        playerPanel.rateBadIcon:SetPoint("TOP", playerPanel, "TOP", 35, -375)
        playerPanel.rateBadIcon:EnableMouse(true)
        playerPanel.rateBadIcon:SetScript('OnEnter', function() playerPanel.rateBadIcon:SetSize(24, 24) end)
        playerPanel.rateBadIcon:SetScript('OnLeave', function() playerPanel.rateBadIcon:SetSize(20, 20) end)
        playerPanel.rateBadIcon:SetScript("OnMouseUp", function()
            playerPanel.rateGoodIcon:SetBackdropColor(0.3, 0.3, 0.3, 1)
            playerPanel.rateBadIcon:SetBackdropColor(0.9, 0.9, 0.9, 1)
            playerPanel.rating = 0
            saveRating(playerPanel)
        end)
        playerPanel.rateBadIcon.text = playerPanel:CreateFontString(nil, "OVERLAY")
        playerPanel.rateBadIcon.text:SetFont("Interface\\Addons\\Minesweeperr\\media\\font.ttf", 12, "THINOUTLINE")
        playerPanel.rateBadIcon.text:SetText("")
        playerPanel.rateBadIcon.text:SetPoint("LEFT", playerPanel.rateBadIcon, "RIGHT", 5, 0)
        playerPanel.rateBadIcon.text:SetTextColor(0.6, 0.6, 0.6, 1)


        -- ----------------------
        if i == 1 then
            playerPanel:SetScript("OnEvent", getAchievementData);
            playerPanel:RegisterEvent("INSPECT_ACHIEVEMENT_READY")
        end

        if i == 2 then
            playerPanel:SetScript("OnEvent", getGearData);
            playerPanel:RegisterEvent("INSPECT_READY")
        end

        if i == 3 then
            playerPanel:SetScript("OnEvent", receivedRatingData);
            playerPanel:RegisterEvent("CHAT_MSG_ADDON")
        end

        if i == 4 then
            playerPanel:SetScript("OnEvent", createWelcome);
            playerPanel:RegisterEvent("ADDON_LOADED")
        end

        panels[i] = playerPanel
        if i > 1 then
            playerPanel:Hide()
        end
    end
    mainFrame:SetScript("OnEvent", getMemberBasicData);
    mainFrame:RegisterEvent("GROUP_ROSTER_UPDATE")
    mainFrame.panels = panels

    local refreshMaskFrame = CreateFrame("Frame", nil, mainFrame)
    refreshMaskFrame:SetSize(1160, 420)
    setFrameTexture(refreshMaskFrame, 1)
    refreshMaskFrame:SetBackdropColor(0, 0, 0, 0.7)
    refreshMaskFrame:SetBackdropBorderColor(0, 0, 0, 1)
    refreshMaskFrame:SetPoint("TOP", mainFrame, "TOP", 0, -40)
    refreshMaskFrame:SetFrameLevel(9)
    local refreshMaskIcon = CreateFrame("Frame", nil, refreshMaskFrame)
    refreshMaskIcon:SetSize(32, 32)
    setFrameTexture(refreshMaskIcon, 0, "Interface\\Addons\\Minesweeperr\\media\\refresh")
    refreshMaskIcon:SetBackdropColor(1, 1, 1, 1)
    refreshMaskIcon:SetBackdropBorderColor(0, 0, 0, 0)
    refreshMaskIcon:SetPoint("BOTTOMRIGHT", refreshMaskFrame, "BOTTOMRIGHT", -240, 40)
    refreshMaskIcon.text = refreshMaskIcon:CreateFontString(nil, "OVERLAY")
    refreshMaskIcon.text:SetFont("Interface\\Addons\\Minesweeperr\\media\\font.ttf", 16, "THINOUTLINE")
    refreshMaskIcon.text:SetText(L["Refreshing"])
    refreshMaskIcon.text:SetPoint("LEFT", refreshMaskIcon, "RIGHT", 5, 0)
    refreshMaskIcon.text:SetTextColor(0.7, 0.7, 0.7, 1)

    mainFrame.refreshMaskFrame = refreshMaskFrame
    mainFrame.refreshMaskFrame:Hide()

    -- --------------
    -- If in a raid
    local raidMaskFrame = CreateFrame("Frame", nil, mainFrame)
    raidMaskFrame:SetSize(1160, 420)
    setFrameTexture(raidMaskFrame, 1)
    raidMaskFrame:SetBackdropColor(0, 0, 0, 0.7)
    raidMaskFrame:SetBackdropBorderColor(0, 0, 0, 1)
    raidMaskFrame:SetPoint("TOP", mainFrame, "TOP", 0, -40)
    raidMaskFrame:SetFrameLevel(9)
    local raidMaskIcon = CreateFrame("Frame", nil, raidMaskFrame)
    raidMaskIcon:SetSize(32, 32)
    setFrameTexture(raidMaskIcon, 0)
    raidMaskIcon:SetBackdropColor(1, 1, 1, 0)
    raidMaskIcon:SetBackdropBorderColor(0, 0, 0, 0)
    raidMaskIcon:SetPoint("CENTER", raidMaskFrame, "CENTER", 0, 0)
    raidMaskIcon.text = raidMaskIcon:CreateFontString(nil, "OVERLAY")
    raidMaskIcon.text:SetFont("Interface\\Addons\\Minesweeperr\\media\\font.ttf", 16, "THINOUTLINE")
    raidMaskIcon.text:SetText(L["InRaid"])
    raidMaskIcon.text:SetPoint("CENTER", raidMaskIcon, "CENTER", 0, 0)
    raidMaskIcon.text:SetTextColor(0.7, 0.7, 0.7, 1)

    mainFrame.raidMaskFrame = raidMaskFrame
    raidMaskFrame:Hide()

    return mainFrame
end


local ratings = {}

function saveRating(playerPanel)
    MSDB[playerPanel.guid] = playerPanel.rating
    _DB[playerPanel.guid]["rating"] = playerPanel.rating
    ratings[playerPanel.guid] = playerPanel.rating
    C_ChatInfo.SendAddonMessage( "MS", toString(ratings), "PARTY" );
end



function receivedRatingData(self, event, prefix, message, distribution, sender)
    if prefix == "MS" then
        if message == "REQUEST_RATINGS" and ratings then
            C_ChatInfo.SendAddonMessage( "MS", toString(ratings), "PARTY" );
        else
            local func = "tmp_ratings = "..message
            loadstring(func)()
            if tmp_ratings then
                if tmp_ratings["SenderGUID"] ~= _PLAYER_GUID then
                    for k, v in pairs(tmp_ratings)
                    do
                        if k ~= "SenderGUID" and tmp_ratings["SenderGUID"] ~= k then
                            if tonumber(v) == 1 then
                                _DB[k]["good_rating_count"][tmp_ratings["SenderGUID"]] = 1
                            else
                                _DB[k]["bad_rating_count"][tmp_ratings["SenderGUID"]] = 1
                            end
                        end
                    end
                end
            end
            refreshPlayerPanels()
        end
    end
end


-- Create user

function getN(map)
    local count = 0
    for k,v in pairs(map) do count = count + 1 end
    return count
end


function getUnitData(unitid)
    local unitInfo = {}
    unitInfo["uid"] = unitid
    local namestr = GetUnitName(unitid, true)
    if namestr == UNKNOWNOBJECT or not namestr
    then
        return nil
    end
    local ts = string.reverse(namestr)  
    local param1, param2 = string.find(ts, "-")
    local name, server
    if param2
    then
       local m = string.len(namestr) - param2 + 1     
       server = string.sub(namestr, m+1, string.len(namestr))   
       name = string.sub(namestr, 1, m-1)  
    else
       name = namestr
       server = GetRealmName()
    end
    unitInfo["name"] = name
    unitInfo["server"] = server
    unitInfo["GUID"] = UnitGUID(unitid)
    if unitid == "player"
    then
        _PLAYER_GUID = unitInfo["GUID"]
    end
    _PARTYMEMBER[unitInfo["GUID"]] = 1
    local localizedClass, englishClass, classIndex = UnitClass(unitid);
    unitInfo["classIndex"] = classIndex
    local role = UnitGroupRolesAssigned(unitid);
    unitInfo["role"] = role
    if MSDB[unitInfo["GUID"]]
    then
        unitInfo["rating"] = MSDB[unitInfo["GUID"]]
    end
    unitInfo["bad_rating_count"] = {}
    unitInfo["good_rating_count"] = {}
    return unitInfo
end

function getPlayerBasicData()
    local playerInfo = getUnitData("player")
    _DB[playerInfo["GUID"]] = playerInfo
end

local _REFRESH_ACHI_FLAG = 0
local _REFRESH_GEAR_FLAG = 0

function getMemberBasicData()
    membersNum = GetNumGroupMembers()
    if membersNum <= 5 then
    -- membersNum = GetNumSubgroupMembers()
        _M.raidMaskFrame:Hide()
        _M.refreshMaskFrame:Show()
        collectgarbage("collect")
        C_ChatInfo.SendAddonMessage( "MS", "REQUEST_RATINGS", "PARTY" );
        getPlayerBasicData()
        
        -- print("Attempt to get member's data, FLAG:".._REFRESH_ACHI_FLAG.._REFRESH_GEAR_FLAG)
        local _PLAYERINFO = _DB[_PLAYER_GUID]
        _PARTYMEMBER = {}
        _PARTYMEMBER[_PLAYERINFO["GUID"]] = 1

        ratings = {}
        ratings["SenderGUID"] = _PLAYER_GUID
        for i = 1, membersNum, 1
        do
            local playerInfo = getUnitData("party"..i)
            if playerInfo
            then
                _DB[playerInfo["GUID"]] = playerInfo
                if playerInfo["GUID"] ~= _PLAYER_GUID then
                    ratings[playerInfo["GUID"]] = playerInfo["rating"]
                end
            end
        end
        for key, value in pairs(_DB)
        do
            if not _PARTYMEMBER[key] and key ~= 1
            then
                _DB[key] = nil
            end
        end
        C_ChatInfo.SendAddonMessage( "MS", toString(ratings), "PARTY" );
        refreshPlayerPanels()
        if _REFRESH_GEAR_FLAG == 0
        then
            _M.refreshMaskFrame:Show()
            getAdvantageGearData()
        end
        if _REFRESH_ACHI_FLAG == 0
        then
            _M.refreshMaskFrame:Show()
            getAdvantageAchievementData()
        end
    else
        _M.raidMaskFrame:Show()
    end
end


_ACHI_FLAGKEY = nil
function getAdvantageAchievementData()
    -- print("Achievement data gathering...")
    -- Get Achievement
    key, value = next(_DB, _ACHI_FLAGKEY)
    _ACHI_FLAGKEY = key
    if _ACHI_FLAGKEY then
        _REFRESH_ACHI_FLAG = 1
        SetAchievementComparisonUnit(value["uid"])
        MS_wait(2, requestAchievementDone)
    else
        _REFRESH_ACHI_FLAG = 0
        if _REFRESH_GEAR_FLAG == 0
        then
            mainFrame.refreshMaskFrame:Hide()
        end
    end
    return
end


function requestAchievementDone()
    ClearAchievementComparisonUnit()
    getAdvantageAchievementData()
end


_GEAR_FLAGKEY = nil
function getAdvantageGearData()
    -- print("Gear data gathering...")
    -- Get Achievement
    key, value = next(_DB, _GEAR_FLAGKEY)
    _GEAR_FLAGKEY = key
    if _GEAR_FLAGKEY then
        _REFRESH_GEAR_FLAG = 1
        -- print("Gathering GData of "..value["uid"])
        NotifyInspect(value["uid"])
        MS_wait(2, requestGearDone)
    else
        _REFRESH_GEAR_FLAG = 0
        if _REFRESH_ACHI_FLAG == 0
        then
            mainFrame.refreshMaskFrame:Hide()
        end
    end
end

function requestGearDone()
    -- print("Request Gear Done.")
    getAdvantageGearData()
end


-- ------------
-- Minimap Icon
local addon = LibStub("AceAddon-3.0"):NewAddon("Minesweeperr", "AceConsole-3.0")
local msLDB = LibStub("LibDataBroker-1.1"):NewDataObject("MS", {
    type = "data source",
    text = "Minesweeperr",
    icon = "Interface\\Icons\\INV_Chest_Cloth_17",
    OnClick = function() mainFrame:Show() end,
    OnTooltipShow = function(tooltip)
		tooltip:AddLine("Minesweeperr")
		tooltip:Show()
	end
})
local icon = LibStub("LibDBIcon-1.0")
 
function addon:OnInitialize()
    self.db = LibStub("AceDB-3.0"):New("msDB", {
        profile = {
            minimap = {
                hide = false,
            },
        },
    })
    icon:Register("MS", msLDB, self.db.profile.minimap)
    self:RegisterChatCommand("ms", "CommandTheMS")
end
 
function addon:CommandTheMS()
    mainFrame:Show()
end

function createWelcome(self, event, name)
    refreshPlayerPanels()
    if name == "Minesweeperr"and FIRSTOPEN == 1 then 
        FIRSTOPEN = 0
        local wcFrame = CreateFrame("Frame", nil, UIParent)
        wcFrame:SetFrameLevel(5)
        wcFrame:SetSize(1024, 1024)
        setFrameTexture(wcFrame, 0)
        wcFrame:SetBackdropColor(0, 0, 0, 0)
        wcFrame:SetBackdropBorderColor(0, 0, 0, 0)
        wcFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
        wcFrame.page = CreateFrame("Frame", "wcpage", wcFrame)
        wcFrame.page:SetSize(1024, 1024)
        setFrameTexture(wcFrame.page, 0, "Interface\\Addons\\Minesweeperr\\media\\wc")
        wcFrame.page:SetBackdropBorderColor(0, 0, 0, 0)
        wcFrame.page:SetPoint("TOP", wcFrame, "TOP", 0, 0)

        local closeBtn = CreateFrame("Frame", nil, wcFrame)
        closeBtn:SetSize(120, 30)
        setFrameTexture(closeBtn, 0, "Interface\\Addons\\Minesweeperr\\media\\normTex")
        closeBtn:SetBackdropColor(0, 0, 0, 0.9)
        closeBtn:SetBackdropBorderColor(0, 0, 0, 1)
        closeBtn:SetPoint("BOTTOM", wcFrame, "BOTTOM", 300, 250)
        closeBtn.Text = closeBtn:CreateFontString(nil, "OVERLAY")
        closeBtn.Text:SetTextColor(0.8, 0.8, 0.8, 1)
        closeBtn.Text:SetFont("Interface\\Addons\\Minesweeperr\\media\\font.ttf", 14, "THINOUTLINE") 
        closeBtn.Text:SetText(L["Close"])
        closeBtn.Text:SetPoint("CENTER", closeBtn, "CENTER", 0, 0)
        closeBtn:EnableMouse(true)
        closeBtn:SetScript("OnMouseUp", function(self) self:GetParent():Hide() end)
        closeBtn:SetScript('OnEnter', function() closeBtn:SetBackdropColor(0.1, 0.1, 0.1, 0.9) end)
        closeBtn:SetScript('OnLeave', function() closeBtn:SetBackdropColor(0, 0, 0, 0.9) end)
    end
end


-- ---------------------
-- Main
-- Create database
MSDB = {}
FIRSTOPEN = 1

_DB = {}
_PARTYMEMBER = {}

if not C_ChatInfo.IsAddonMessagePrefixRegistered("MS") then
    C_ChatInfo.RegisterAddonMessagePrefix("MS")
end


mainFrame = createBasicUI()
_M = mainFrame

mainFrame:Hide()
getPlayerBasicData()
getAdvantageAchievementData()
getAdvantageGearData()
refreshPlayerPanels()
